/******************************************************************************
 *
 *  建立命名空间
 *
 ******************************************************************************/
//建立一级域名
var cn;
if(!cn) cn = {};

//建立二级域名
if(!cn.dict) cn.dict = {};

/**
 *
 *  API版本号
 *
 */
cn.dict.version = 2.0;

/******************************************************************************
 *
 *  私有方法和变量
 *
 ******************************************************************************/
 var __giframeId__ = 1;
 
 function __createIFrameId__() {
     return "__native_iframe_hidden_" + (__giframeId__ ++);
 }
 
 function __createHiddenIFrame__() {
    var iframe = document.createElement("iframe");
    iframe.id = __createIFrameId__();
    iframe.style.display = 'none';
    return iframe;
}

function __createNaviteURL__(commServiceUrl,module,action,iframeId,jsonString) {
    var url = commServiceUrl;
    if(module) 
        url += "&" + "module=" + module;
    if(action)
        url += "&" + "action=" + action;
    if(iframeId)
        url += "&" + "iframeId=" + iframeId;
    if(jsonString) 
        url += "&" + "jsonString=" + encodeURI(jsonString);
    return url;
}
 

/******************************************************************************
 *
 *  native service模块
 *
 ******************************************************************************/
if(!cn.dict.NaitveServiceManager) cn.dict.NaitveServiceManager = {};
//协议名
cn.dict.NaitveServiceManager.PROTOCOL = "native";

//公共服务url
cn.dict.NaitveServiceManager.COMMON_SERVICE_URL = cn.dict.NaitveServiceManager.PROTOCOL + "://" + "common" +  "?" + "version=" + cn.dict.version;
cn.dict.NaitveServiceManager.ScbModuleName = "scb";
cn.dict.NaitveServiceManager.AudioModuleName = "audio";
cn.dict.NaitveServiceManager.UIModuleName = "ui";


//全局快捷访问方式
var _gCommonServiceUrl = cn.dict.NaitveServiceManager.COMMON_SERVICE_URL;

/******************************************************************************
 *
 *  生词本管理模块
 *
 ******************************************************************************/
//建立生词本管理模块
if(!cn.dict.ScbManager) cn.dict.ScbManager = {}
/**
    添加生词本单词
    
    @param  jsonString: 参数列表数据
            
            格式：
            jsonString = {
                "wid":"",                                 //wid
                "successCallback":"onScbSuccess",         //成功回调函数
                "failedCallback":"onScbFailed"            //失败回调函数
            }
     
    @return void
 */
cn.dict.ScbManager.addScb = function(jsonString) {
    var actionName = "addScb";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.ScbModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

//生词本快捷访问对象
var _ScbMgr = cn.dict.ScbManager;

/******************************************************************************
 *
 *  发音管理模块
 *
 ******************************************************************************/

//建立声音管理模块
if(!cn.dict.AudioManager) cn.dict.AudioManager = {}

/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "lang":"b",                                 //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "url":"url"                                //mp3地址，支持url发音
 *     "startCallback":"onStartPlaySound",         //开始播放动画js回调
 *     "endCallback":"onEndPlaySound"              //停止播放动画js回调
 * }
 */
cn.dict.AudioManager.playSound = function(jsonString) {
    var actionName = "playSound";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.AudioModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

//生词本快捷访问对象
var _AudioMgr = cn.dict.AudioManager;

/******************************************************************************
 *
 *  UI控制模块
 *
 ******************************************************************************/
//建立生词本管理模块
if(!cn.dict.UIManager) cn.dict.UIManager = {}

/**
 查词跳转
    jsonString 格式
 
    {
        "text" : "查词关键字"
    }
 */
cn.dict.UIManager.searchWord = function(jsonString) {
    var actionName = "searchWord";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}

cn.dict.UIManager.ajaxSearch = function(jsonString) {
    var actionName = "ajaxSearch";
    var iframeElement = __createHiddenIFrame__();
    iframeElement.src = __createNaviteURL__(_gCommonServiceUrl,cn.dict.NaitveServiceManager.UIModuleName,actionName,iframeElement.id,jsonString);
    document.body.appendChild(iframeElement);
}




//生词本快捷访问对象
var _UIMgr = cn.dict.UIManager;

var dictcn;
if(!dictcn) dictcn = {};
dictcn.addScb = _ScbMgr.addScb;
dictcn.playSound = _AudioMgr.playSound;
dictcn.searchText = _UIMgr.searchWord;
dictcn.ajaxSearch = cn.dict.UIManager.ajaxSearch;
